;================================================
;	POCKET COMMAND G850
;	ver 1.00
;	for PC-G850 series
;	AASM 3.70
;	2006-12
;	by CHOI KYUN ikyun26@yahoo.co.jpj
;================================================



	include	"MACRO.ASM"		;{}N
	include "DEF.ASM"		;e`

	org	0100h



Init:
	call	Cls			;ʏ
	call	Init_KEY		;L[
	call	Init_LCDC		;LCDC
	call	Init_BEEP		;BEEP

	call	Print_CREDIT		;ҕ\
	call	Title			;^Cg\

	call	Randomize		;



	ld	hl,game_stat		;Q[̏
	ld	(hl),0

	call	InitHisc		;nCXRA
ReStart:
	call	InitValue		;eϐ
	call	InitStatus		;Xe[^Xʏ

	call	Ready			;X^[g



Main:
	{
		call	Inkey		;L[
		call	AddLineScreen	;CpXN[

		call	MoveCursor	;J[\ړ
		call	DispCursor	;J[\\

		call	LaunchMyMissile	;@~TC
		call	LaunchEnemyMissile;G~TC

		call	MoveMyMissile	;@~TCړ
		call	MoveEnemy	;G~TCړ

		call	SetUFO		;ten
		call	MoveUFO
		call	DispUFO

		call	DispSAMSite	;C{ss\
		call	DispBlast	;\

		call	ChangeSE	;ʉ؂芷
		call	DispScreen	;XN[\

		call	Clear		;NA
		call	GameOver	;Q[I[o[
		call	Pause		;|[Y

		in	a,(01fh)	;[BREAK]L[ŏI
		rlca
		jr	nc,continue
	}



Basic:
	call	Cls
	call	InfoVer_GAME		;o[W\
	call	InfoVer_LIB
	ret



;------------------------------------------------
;	^Cg\
;------------------------------------------------
Title:
	call	Print_TITLE
	call	DispScreen
	call	Print_SE
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	ClearFullScreen

	call	Se2
	ld	bc,600
	call	Wait
	ret


	;^Cg\
Print_TITLE:
	ld	d,1
	ld	hl,Title_data
	{
		ld	e,23+SCREEN_BLANK
		ld	bc,97
		call	PutBitmap
		add	hl,bc
		inc	d
		ld	a,d
		cp	7
		jr	nz,continue
	}
	ret



;------------------------------------------------
;	ϐ
;------------------------------------------------
InitValue:
	call	ClearLineScreen		;CXN[NA
	call	InitUFO			;UFO

	ld	a,1			;J[\EFCg
	ld	(cur_wait),a

	ld	a,1			;~TC˃EFCg
	ld	(launch_wait),a

	ld	a,DEF_MY_MISSILE_WAIT	;@~TCړEFCg
	ld	(my_missile_wait),a

	ld	hl,28*256+44+SCREEN_BLANK;J[\W
	ld	(cur_x),hl

	xor	a
	ld	(my_m_count),a		;~TCJEg
	ld	(bomb_count),a		;JEg
	ld	(enemy_count),a		;G~TCJEg

	{
		ld	a,(game_stat)
		or	a
		jr	nz,break

		call	InitLevel		;x
		call	InitScore		;XRA
		call	InitCity		;ss
		call	InitEnemy		;G~TC̏
	}
	xor	a
	ld	(game_stat),a		;Q[̐is
	ret



	;x
InitLevel:
	ld	a,1
	ld	(level),a

	ld	hl,my_missile_num
	ld	(hl),DEF_MISSILE_NUM		;ce
	inc	hl
	ld	(hl),DEF_MISSILE_NUM_BCD

	ld	hl,lv_enemy_launch_wait		;G~TCˊԊu
	ld	(hl),DEF_ENEMY_WAIT
	inc	hl

	ld	(hl),DEF_ENEMY_MOVE_WAIT	;G~TCړEFCg
	ret


	;ʓss̏
InitCity:
	ld	hl,city_num			;css
	ld	(hl),6

	ld	b,6
	ld	hl,CityBuf
	{
		ld	(hl),DEF_CITY_LEVEL	;j󃌃x
		inc	hl
		djnz	continue
	}
	ret


	;G~TC̏
InitEnemy:
	ld	hl,enemy_count
	ld	(hl),0
	inc	hl

	ld	(hl),DEF_ENEMY_WAIT	;˃EFCg
	inc	hl

	ld	(hl),DEF_ENEMY_NUM	;x1̒e
	inc	hl

	ld	(hl),DEF_ENEMY_NUM_BCD	;x1̒e@\p
	ret


	;UFȌ
InitUFO:
	xor	a
	ld	(ufo_flg),a		;UFOotO

	ld	a,DEF_SET_UFO_WAIT	;UFOoEFCg
	ld	(set_ufo_wait),a

	ld	a,DEF_UFO_WAIT		;UFOړEFCg
	ld	(ufo_wait),a
	ret


	;CXN[NA
ClearLineScreen:
	ld	hl,LineBuf
	ld	de,LineBuf+1
	ld	bc,SCREEN_WIDTH*SCREEN_HEIGHT-1
	ld	(hl),0
	ldir
	ret



;------------------------------------------------
;	Q[JnI
;------------------------------------------------
Ready:
	call	AddLineScreen
	call	DispSAMSite

	call	Print_READY_LV
	call	Print_ENEMY
	call	Print_PUSH
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	Se2

	ld	bc,1000
	call	Wait
	ret



Print_READY_LV:
	ld	hl,Mes_LEVEL			;LEVEL
	ld	de,1*256+28+SCREEN_BLANK	;28,2
	ld	bc,31
	call	PutBitmap

	ld	hl,Font_NUM_L
	ld	(_patch_num_font+1),hl

	ld	hl,level
	ld	de,1*256+60+SCREEN_BLANK	;60,2
	call	PutBCD

	ld	hl,Font_NUM
	ld	(_patch_num_font+1),hl
	ret


Print_ENEMY:
	ld	hl,Mes_ENEMY			;ENEMY
	ld	de,2*256+14+SCREEN_BLANK	;14,2
	ld	bc,31
	call	PutBitmap

	ld	hl,Font_NUM_L
	ld	(_patch_num_font+1),hl

	ld	hl,bcd_enemy_num
	ld	de,2*256+54+SCREEN_BLANK	;60,2
	call	PutBCD

	ld	hl,Font_NUM
	ld	(_patch_num_font+1),hl

	ld	hl,Mes_MISSILE			;MISSILE
	ld	de,3*256+14+SCREEN_BLANK	;14,3
	ld	bc,39
	call	PutBitmap

	call	Score_MISSILE
	ret



;------------------------------------------------
;	Q[NA
;------------------------------------------------
Clear:
	ld	a,(game_stat)
	bit	FLG_CLEAR,a
	ret	z

	ld	bc,1000
	call	Wait

	call	Se4
	call	Se4

	call	Print_CLEAR
	call	Print_PUSH
	call	Score_CITY
	call	Score_MISSILE
	call	AddScore			;XRAZ
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	LevelUp				;xAbv
	call	Se2

	ld	bc,1000
	call	Wait

	pop	af
	jp	ReStart



Print_CLEAR:
	ld	hl,Mes_CLEAR			;CLEAR
	ld	de,1*256+14+SCREEN_BLANK	;14,1
	ld	bc,68
	call	PutBitmap

	ld	hl,Mes_CITY			;CITY
	ld	de,2*256+14+SCREEN_BLANK	;10,2
	ld	bc,26
	call	PutBitmap

	ld	hl,Mes_MISSILE			;MISSILE
	ld	de,3*256+14+SCREEN_BLANK	;10,3
	ld	bc,39
	call	PutBitmap

	ld	hl,Mes_POINT200			;x200
	ld	de,2*256+64+SCREEN_BLANK	;64,2
	ld	bc,20
	call	PutBitmap

	ld	hl,Mes_POINT50			;x50
	ld	de,3*256+64+SCREEN_BLANK	;64,3
	ld	bc,15
	call	PutBitmap
	ret



Print_PUSH:
	ld	hl,Mes_PUSH			;PUSH...
	ld	de,5*256+8+SCREEN_BLANK		;8,5
	ld	bc,80
	jp	PutBitmap



;------------------------------------------------
;	Q[I[o[
;------------------------------------------------
GameOver:
	ld	a,(game_stat)
	bit	FLG_OVER,a
	ret	z

	ld	bc,1200
	call	Wait

	call	Se3

	call	Print_OVER
	call	Print_PUSH
	call	CmpHisc				;nCXRAL^
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	call	Se2

	ld	bc,1000
	call	Wait

	xor	a
	ld	(game_stat),a
	pop	af
	jp	ReStart



Print_OVER:
	ld	hl,Mes_OVER			;GAME OVER
	ld	de,3*256+23+SCREEN_BLANK	;23,3
	ld	bc,50
	jp	PutBitmap



;------------------------------------------------
;	|[Y
;------------------------------------------------
Pause:
	ld	a,(keyf)
	bit	KEY_SHIFT,a
	ret	z

	call	Se2
	call	Print_PAUSE
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SHIFT,a
		jr	z,continue
	}
	call	Se2
	ret



Print_PAUSE:
	ld	hl,Mes_PAUSE
	ld	de,6*256+0+SCREEN_BLANK		;0,6
	ld	bc,20
	jp	PutBitmap



;------------------------------------------------
;	J[\ړ
;------------------------------------------------
MoveCursor:
	ld	hl,cur_wait
	dec	(hl)
	ret	nz

	ld	(hl),1

	ex	de,hl
	ld	hl,key
_UP:
	bit	KEY_8,(hl)
	jr	z,_DOWN

	ld	a,(cur_y)
	cp	12
	jr	c,_DOWN

	sub	2
	ld	(cur_y),a

	ld	a,DEF_CUR_WAIT
	ld	(de),a
	jr	_LEFT

_DOWN:
	bit	KEY_2,(hl)
	jr	z,_LEFT

	ld	a,(cur_y)
	cp	47-5
	jr	nc,_LEFT

	add	a,2
	ld	(cur_y),a

	ld	a,DEF_CUR_WAIT
	ld	(de),a

_LEFT:
	bit	KEY_4,(hl)
	jr	z,_RIGHT

	ld	a,(cur_x)
	cp	SCREEN_BLANK+1
	jr	c,_RIGHT

	sub	2
	ld	(cur_x),a

	ld	a,DEF_CUR_WAIT
	ld	(de),a
	ret

_RIGHT:
	bit	KEY_6,(hl)
	ret	z

	ld	a,(cur_x)
	cp	96-6+SCREEN_BLANK
	ret	nc

	add	a,2
	ld	(cur_x),a

	ld	a,DEF_CUR_WAIT
	ld	(de),a
	ret



;------------------------------------------------
;	J[\\
;------------------------------------------------
DispCursor:
	ld	de,(cur_x)
	ld	hl,Chr_CURSOR
	jp	PutChr



;------------------------------------------------
;	@~TC
;------------------------------------------------
LaunchMyMissile:
	ld	hl,launch_wait
	dec	(hl)
	ret	nz

	ld	(hl),1

	ld	a,(key)
	bit	KEY_SPC,a
	ret	z

	ld	a,(my_m_count)
	cp	MAX_MY_MISSILE
	ret	nc

	ld	a,(my_missile_num)	;ce
	or	a
	ret	z
	dec	a
	ld	(my_missile_num),a

	call	SetMyMissileData	;~TCf[^쐬

	ld	hl,launch_wait
	ld	(hl),DEF_LAUNCH_WAIT	;EFCg

	ld	hl,my_m_count		;~TCJEg
	inc	(hl)

	ld	hl,bcd_my_missile_num	;ceBCD
	ld	a,(hl)
	sub	1
	daa
	ld	(hl),a

	call	DispMissileNum		;ce\
	jp	Se2



;------------------------------------------------
;	G~TC
;------------------------------------------------
LaunchEnemyMissile:
	ld	hl,enemy_wait
	dec	(hl)
	ret	nz

	ld	a,(lv_enemy_launch_wait)
	ld	(hl),a			;ˊԊu

	ld	a,(enemy_count)		;ő哯\
	cp	MAX_ENEMY
	ret	nc

	ld	b,a
	{
		ld	a,(enemy_num)		;ce
		or	a
		jr	nz,break

		ld	a,b
		or	a
		ret	nz

		inc	a
		ld	(game_stat),a		;NA
		ret
	}
	call	Rnd
	and	3			;1/4̊m
	ret	nz

	call	SetEnemyData		;~TCf[^쐬

	ld	hl,enemy_count
	inc	(hl)

	ld	hl,enemy_num		;Gce
	dec	(hl)

	ld	a,(bcd_enemy_num)	;Gce \p
	sub	1
	daa
	ld	(bcd_enemy_num),a

	call	DispEnemyNum		;ce\
	ret



;------------------------------------------------
;	UFOZbg
;------------------------------------------------
SetUFO:
	ld	hl,set_ufo_wait
	dec	(hl)
	ret	nz

	ld	(hl),DEF_SET_UFO_WAIT

	call	Rnd
	and	15
	ret	nz

	ld	a,(ufo_flg)
	or	a
	ret	nz

	call	Rnd		;ړ@0:ړ@1:ړ 128:ړ
	and	1
	ld	(ufo_inc),a

	ld	b,16
	{
		or	a
		jr	z,break
		ld	b,96+SCREEN_BLANK-8
	}
	ld	a,b		;XW 8 or 96
	ld	(ufo_x),a

	call	Rnd
	and	7
	add	a,8		;YW 0..7
	ld	(ufo_y),a

	call	Rnd
	and	7
	add	a,4
	ld	(ufo_step),a	;Xebv

	xor	a
	ld	(ufo_stop_wait),a

	inc	a
	ld	(ufo_flg),a	;tO
	ret



;------------------------------------------------
;	@~TCf[^쐬
;------------------------------------------------
SetMyMissileData:
	ld	a,(my_m_count)
	add	a,a
	add	a,a
	add	a,a
	add	a,a		;*16
	ld	e,a
	ld	d,0
	ld	hl,MyMissileBuf
	add	hl,de

	ld	(hl),-1			;+0 tO
	inc	hl

	ld	a,SAM_X+SCREEN_BLANK	;+1 n_X
	ld	b,SAM_Y			;+2 n_Y
	ld	(hl),a
	inc	hl
	ld	(hl),b
	inc	hl

	ld	(hl),a			;+3 X
	inc	hl
	ld	(hl),b			;+4 Y
	inc	hl

	ld	a,(cur_x)
	add	a,2		;␳
	ld	c,a		;XI_

	ld	a,(cur_y)
	add	a,2		;␳
	ld	d,a		;YI_

	ld	(hl),-1
	ld	a,c
	{
		cp	SAM_CENTER+SCREEN_BLANK
		jr	c,break
		ld	(hl),1		;+5 Xړi-1 or 1j
	}
	inc	hl
;X1-X0
	ld	a,SAM_X+SCREEN_BLANK
	{
		sub	c
		jr	nc,break
		neg
	}
	ld	c,a		;X
	inc	c
;Y1-Y0
	ld	a,SAM_Y
	{
		sub	d
		jr	nc,break
		neg
	}
	ld	d,a		;Y
	inc	d

	ld	(hl),0
	ld	a,c		;A=ŏIJEg
	ld	e,d		;E=덷l
	{
		cp	d	;l̑傫x[XɂȂ
		jr	nc,break
		ld	(hl),1		;+6 x[XtOi0:X,1:Yj
		ld	a,d	;A=ŏIJEg
		ld	e,c	;E=덷l
	}
	inc	hl

	ld	(hl),0			;+7 ݋JEg
	inc	hl

	ld	(hl),a			;+8 ŏIJEg
	inc	hl

	ld	(hl),DEF_MY_MISSILE_WAIT;+9 EFCg
	inc	hl

	ld	(hl),DEF_MY_MISSILE_WAIT;+10 EFCg[h
	inc	hl

	ld	(hl),0			;+11 덷JEg
	inc	hl

	ld	(hl),e			;+12 덷l
	ret



;------------------------------------------------
;	G~TCf[^쐬
;------------------------------------------------
SetEnemyData:
	ld	a,(enemy_count)
	add	a,a
	add	a,a
	add	a,a
	add	a,a			;*16
	ld	e,a
	ld	d,0
	ld	hl,EnemyBuf
	add	hl,de

	ld	(hl),1			;+0@tO
	inc	hl

	{
		call	Rnd
		and	127
		cp	96
		jr	nc,continue
	}
	add	a,SCREEN_BLANK
	ld	e,a
	ld	(hl),a			;+1@n_X
	inc	hl

	ld	(hl),7			;+2@n_Y
	inc	hl

	ld	(hl),a			;+3@XW
	inc	hl

	ld	(hl),7			;+4@YW
	inc	hl

	{
		call	rnd
		and	127
		cp	96-4
		jr	nc,continue
		add	a,SCREEN_BLANK

		cp	e		;n_=I_?
		jr	z,continue

		ld	b,-1
		jr	c,break
		ld	b,1
	}
	ld	(hl),b			;+5@Xړ
	inc	hl
	{
		sub	e		;X
		jr	nc,break
		neg
	}
	inc	a

	ld	(hl),0			;
	ld	d,a			;D=JEg
	ld	e,46			;E=덷l
	{
		cp	46
		jr	nc,break
		ld	(hl),1		;+6@x[XtO
		ld	d,46
		ld	e,a
	}
	inc	hl

	ld	(hl),1			;+7@݋JEg
	inc	hl

	ld	(hl),d			;+8@ŏIJEg
	inc	hl

	ld	a,(lv_enemy_move_wait)
	ld	(hl),a			;+9@EGCg
	inc	hl

	ld	(hl),a			;+10@EFCg[h
	inc	hl

	ld	(hl),0			;+11@덷JEg
	inc	hl

	ld	(hl),e			;+12@덷l
	ret



;------------------------------------------------
;	UFO~TCf[^쐬
;------------------------------------------------
SetUFOMissileData:
	ld	a,(enemy_count)
	add	a,a
	add	a,a
	add	a,a
	add	a,a			;*16
	ld	e,a
	ld	d,0
	ld	hl,EnemyBuf
	add	hl,de

	ld	(hl),1			;+0@tO
	inc	hl

	ld	de,(ufo_x)
	ld	a,4
	add	a,e
	ld	e,a
	ld	(hl),a			;+1@n_X
	inc	hl

	ld	a,3
	add	a,d
	ld	d,a
	ld	(hl),a			;+2@n_Y
	inc	hl

	ld	(hl),e			;+3@݂XW
	inc	hl

	ld	(hl),d			;+4@݂YW
	inc	hl

	{
		call	rnd
		and	127
		cp	96-4
		jr	nc,continue
		add	a,SCREEN_BLANK

		cp	e		;n_=I_?
		jr	z,continue

		ld	b,-1
		jr	c,break
		ld	b,1
	}
	ld	(hl),b			;+5@Xړ
	inc	hl

;X1-X0
	{
		sub	e
		jr	nc,break
		neg
	}
	ld	c,a			;X
	inc	c
;Y1-Y0
	ld	a,43+8
	{
		sub	d
		jr	nc,break
		neg
	}
	ld	d,a			;Y
	inc	d

	ld	(hl),0
	ld	a,c		;A=ŏIJEg
	ld	e,d		;E=덷l
	{
		cp	d	;l̑傫x[XɂȂ
		jr	nc,break
		ld	(hl),1		;+6 x[XtOi0:X,1:Yj
		ld	a,d	;A=ŏIJEg
		ld	e,c	;E=덷l
	}
	inc	hl

	ld	(hl),0			;+7 ݋JEg
	inc	hl

	ld	(hl),a			;+8 ŏIJEg
	inc	hl

	ld	(hl),UFO_MISSILE_WAIT	;+9 EFCg
	inc	hl

	ld	(hl),UFO_MISSILE_WAIT	;+10 EFCg[h
	inc	hl

	ld	(hl),0			;+11 덷JEg
	inc	hl

	ld	(hl),e			;+12 덷l
	ret



;------------------------------------------------
;	f[^쐬
;	in	de:	XYW
;------------------------------------------------
SetNewBomb:
	ld	a,(bomb_count)		;ꉞ
	cp	MAX_BOMB
	ret	nc

	add	a,a
	add	a,a
	add	a,a
	add	a,a			;*16
	ld	hl,BombBuf
	ld	c,a
	ld	b,0
	add	hl,bc

	xor	a
	ld	(hl),a			;tO
	inc	hl

	ld	(hl),a			;Ajp^[
	inc	hl

	ld	(hl),DEF_BOMB_WAIT	;EFCg
	inc	hl

	ld	a,e			;ʒu␳
	sub	4
	ld	(hl),a			;XYW
	inc	hl

	ld	a,d
	sub	4
	ld	(hl),a

	ld	hl,bomb_count
	inc	(hl)

	call	Se1
	ret



;------------------------------------------------
;	@~TCړ
;------------------------------------------------
MoveMyMissile:
	ld	a,(my_m_count)
	ld	hl,MyMissileBuf+15
	call	MoveObj

	ld	(my_m_count),a
	ret



;------------------------------------------------
;	G~TCړ
;------------------------------------------------
MoveEnemy:
	ld	a,(enemy_count)
	ld	hl,EnemyBuf+15
	call	MoveObj

	ld	(enemy_count),a
	ret



;------------------------------------------------
;	\
;------------------------------------------------
DispBlast:
	ld	a,(bomb_count)
	ld	hl,BombBuf+15
	call	MoveObj

	ld	(bomb_count),a
	ret



;------------------------------------------------
;	eIuWFNgړ^\
;	in:	A	IuWFNg
;		HL	obt@
;	out:	A	IuWFNg
;------------------------------------------------
MoveObj:
	or	a			;CP 0
	ret	z

	ld	b,a
	ld	c,a			;B=C=JEg

	dec	a
	add	a,a
	add	a,a
	add	a,a
	add	a,a			;*16
	ld	e,a
	ld	d,0
	add	hl,de

	ld	e,l			;HL@obt@̃Gh|C^
	ld	d,h			;DE@obt@̃Jg|C^
	{
		{
			call	_move_obj_sub
			jr	nc,break		;CY@폜tO

			;obt@폜
			dec	c			;JEg

			push	de
			push	bc
			ld	bc,16
			lddr				;DE-- = HL-- *16

			pop	bc
			pop	de
		}
		push	hl
		ld	hl,-16
		add	hl,de		;|C^i߂
		ex	de,hl		;DE-=16

		pop	hl
		djnz	continue
	}
	ld	a,c	;JEg
	ret



;------------------------------------------------
;	eIuWFNg@~TCA
;	in:	DE	Jgobt@
;	out:	Cy	1:폜
;------------------------------------------------
_move_obj_sub:
	push_all
	ld	ixl,e
	ld	ixh,d			;LD IX,DE

	ld	a,(ix+0f1h)		;ix-15
	or	a			;tO
	jp	z,_disp_blast		;

	dec	(ix+0fah)		;EFCg
	jp	nz,_move_obj_ret

	ld	a,(ix+0fbh)
	ld	(ix+0fah),a		;EFCg[h

	ld	e,(ix+0f4h)		;XYW
	ld	d,(ix+0f5h)
	{
		ld	a,(ix+0f8h)
		inc	a		;݋JEg+1
		ld	(ix+0f8h),a

		cp	(ix+0f9h)	;I
		jr	c,break

		call	CheckHitCity	;ss̓蔻
		call	SetNewBomb	;Zbg
		call	EraseLine	;C

		pop_all
		scf			;Cy=1ŏI
		ret
	}
	ld	c,(ix+0fdh)		;덷l

	ld	l,(ix+0f6h)		;XړtO
	ld	h,(ix+0f1h)		;YړtO

	ld	a,(ix+0f7h)		;x[XtO
	or	a
	jr	nz,_base_y


	;Xx[X
_base_x:
	ld	a,e
	add	a,l
	ld	e,a			;--X or X++
	{
		ld	a,(ix+0fch)	;덷JEg
		add	a,c
		ld	b,a
		cp	(ix+0f9h)	;X < Y
		jr	c,break

		sub	(ix+0f9h)	;덷JEg|ŏIJEg
		ld	b,a

		ld	a,d
		add	a,h
		ld	d,a		;--Y or Y++
	}
	ld	(ix+0fch),b		;덷JEgۑ

	call	Pset			;_`

	ld	(ix+0f4h),e		;݂XYWۑ
	ld	(ix+0f5h),d
	{
		call	CheckHitMissile		;~TCƔ̓蔻
		jr	nc,break

		pop_all
		scf
		ret
	}
	pop_all
	or	a			;Cy=0
	ret


	;Yx[X
_base_y:
	ld	a,d
	add	a,h
	ld	d,a			;--Y or Y++
	{
		ld	a,(ix+0fch)	;덷JEg
		add	a,c
		ld	b,a
		cp	(ix+0f9h)	;Y < X
		jr	c,break

		sub	(ix+0f9h)	;덷JEg|ŏIJEg
		ld	b,a

		ld	a,e
		add	a,l
		ld	e,a		;--X or X++
	}
	ld	(ix+0fch),b		;덷JEgۑ

	call	Pset

	ld	(ix+0f4h),e		;݂XYWۑ
	ld	(ix+0f5h),d
	{
		call	CheckHitMissile		;~TCƔ̓蔻
		jr	nc,break

		pop_all
		scf
		ret
	}
_move_obj_ret:
	pop_all
	or	a
	ret



	;\
_disp_blast:
	ld	a,(ix+0f2h)
	{
		dec	(ix+0f3h)	;EFCg
		jr	nz,break
		ld	(ix+0f3h),DEF_BOMB_WAIT

		inc	a		;Ajp^[
		ld	(ix+0f2h),a
		cp	4
		jr	c,break

		pop_all
		scf		;Cy=1
		ret
	}
	add	a,a
	add	a,a
	add	a,a
	ld	hl,Chr_BOMB
	ld	c,a
	ld	b,0
	add	hl,bc

	ld	e,(ix+0f4h)		;DE=XYW
	ld	d,(ix+0f5h)

	call	PutChr

	pop_all
	or	a		;Cy=0
	ret



;------------------------------------------------
;	C
;	in:	ix		~TCf[^
;------------------------------------------------
Eraseline:
	ld	e,(ix+0f2h)		;n_XY
	ld	d,(ix+0f3h)

	ld	b,(ix+0f9h)		;ŏIJEg
	ld	c,0			;덷lJEg

	ld	l,(ix+0f6h)		;XړtO
	ld	h,(ix+0f1h)		;YړtO

	ld	a,(ix+0f7h)		;x[XtO
	or	a
	jr	nz,_erase_y

_erase_x:
	{
		ld	a,e
		add	a,l
		ld	e,a			;--X or X++
		{
			ld	a,(ix+0fdh)	;덷l
			add	a,c
			ld	c,a
			cp	(ix+0f9h)	;X < Y
			jr	c,break

			sub	(ix+0f9h)	;덷JEg|ŏIJEg
			ld	c,a

			ld	a,d
			add	a,h
			ld	d,a		;--Y or Y++
		}
		call	Preset			;_

		djnz	continue
	}
	ret


_erase_y:
	{
		ld	a,d
		add	a,h
		ld	d,a			;--Y or Y++
		{
			ld	a,(ix+0fdh)	;덷l
			add	a,c
			ld	c,a
			cp	(ix+0f9h)	;X < Y
			jr	c,break

			sub	(ix+0f9h)	;덷JEg|ŏIJEg
			ld	c,a

			ld	a,e
			add	a,l
			ld	e,a		;--X or X++
		}
		call	Preset			;_

		djnz	continue
	}
	ret



;------------------------------------------------
;	~TCƔ̓蔻
;	in:	IX	~TCobt@
;		DE	XYW
;	out:	Cy=1	
;------------------------------------------------
CheckHitMissile:
	ld	a,(ix+0f1h)		;tO
	dec	a			;G~TĈ
	jr	nz,_check_hit_no_hit

	ld	a,(bomb_count)
	or	a
	jr	z,_check_hit_no_hit

	ld	b,a			;JEg
	ld	hl,BombBuf+3
	{
;XW
		ld	c,(hl)			;x1-x0<w
		inc	hl
		ld	a,e
		sub	c
		cp	8
		jr	nc,_check_next
;YW
		ld	c,(hl)			;y1-y0<w
		ld	a,d
		sub	c
		cp	8
		jr	nc,_check_next

		call	SetNewBomb		;Zbg
		call	EraseLine		;C
		scf				;Cy=1
		ret

_check_next:
		ld	a,16-1
		add	a,l
		ld	l,a
		adc	a,h
		sub	l
		ld	h,a			;ADD HL,A

		djnz	continue
	}
_check_hit_no_hit:
	or	a				;Cy=0
	ret



;------------------------------------------------
;	~TCƓss̓蔻
;	in:	IX	~TCobt@
;	in:	E	XW
;------------------------------------------------
CheckHitCity:
	ld	a,(ix+0f1h)
	dec	a
	ret	nz

_check_hit_samsite:
	ld	a,e
	sub	44+SCREEN_BLANK
	cp	7
	jr	nc,_check_hit_city

	ld	a,0000_0010b			;Q[I[o[
	ld	(game_stat),a
	ret



_check_hit_city:
	ld	hl,City_coord_data		;ssW
	ld	c,0				;ssԍ
	{
		ld	b,(hl)
		ld	a,e
		sub	b
		cp	12
		jr	c,_crash_city

		inc	hl
		inc	c

		ld	a,c
		cp	6
		jr	nz,continue
	}
	ret


	;ssj
_crash_city:
	ld	hl,CityBuf
	ld	b,0
	add	hl,bc
	{
		ld	a,(hl)
		cp	2			;łĂ
		jr	nc,break

		inc	(hl)
		ld	a,(hl)
		cp	2
		jr	nz,break

		ld	hl,city_num		;ss-1
		dec	(hl)

		ld	a,(hl)			;SłȂ
		or	a
		jr	nz,break

		ld	a,0000_0010b		;Q[I[o[
		ld	(game_stat),a
	}
	ret



;------------------------------------------------
;	xAbv
;------------------------------------------------
LevelUp:
	{
		ld	a,(level)
		cp	8
		jr	nc,break			;ōLv8

		inc	a
		ld	(level),a			;LEVEL+1

		ld	a,(lv_enemy_launch_wait)	;G~TCˊԊu
		sub	8
		ld	(lv_enemy_launch_wait),a

		ld	a,(lv_enemy_move_wait)		;G~TCړEFCg
		sub	5
		ld	(lv_enemy_move_wait),a
	}
	ld	a,(level)
	dec	a
	add	a,a
	ld	hl,Level_table
	ld	c,a
	ld	b,0
	add	hl,bc

	ld	a,(hl)
	ld	b,a
	ld	(enemy_num),a		;G~TC
	inc	hl

	ld	a,(hl)
	ld	c,a
	ld	(bcd_enemy_num),a	;G~TCBCD

	ld	a,b			;~TC
	ld	hl,my_missile_num
	{
		add	a,(hl)
		cp	99		;ő99
		jr	c,break
		ld	a,99
	}
	ld	(hl),a

	ld	a,c			;~TCBCD
	ld	hl,bcd_my_missile_num
	{
		add	a,(hl)
		daa
		cp	099h
		jr	c,break
		ld	a,099h
	}
	ld	(hl),a

	ret



;------------------------------------------------
;	UFOړ
;------------------------------------------------
MoveUFO:
	ld	a,(ufo_flg)
	or	a
	ret	z

	ld	hl,ufo_wait
	dec	(hl)
	ret	nz

	ld	(hl),DEF_UFO_WAIT
	{
		ld	a,(ufo_stop_wait);ꎞ~
		or	a
		jr	z,break

		dec	a
		ld	(ufo_stop_wait),a
		ret
	}
	{
		ld	hl,ufo_step
		dec	(hl)
		jr	nz,break

		call	Rnd
		and	15
		add	a,4
		ld	(ufo_stop_wait),a;ꎞ~

		ld	a,(ufo_inc)
		or	1000_0000b	;ړtO
		ld	(ufo_inc),a

		call	LaunchUFOMissile;~TC
		ret
	}
	ld	de,(ufo_x)

	ld	a,(ufo_inc)
	bit	7,a
	jr	nz,_move_ufo_up
	bit	0,a
	jr	nz,_move_ufo_left


	;Eړ
_move_ufo_right:
	inc	e
	inc	e
	inc	e
	inc	d
	ld	(ufo_x),de
	ret


	;ړ
_move_ufo_left:
	dec	e
	dec	e
	dec	e
	inc	d
	ld	(ufo_x),de
	ret


	;ړ
_move_ufo_up:
	inc	e
	{
		bit	0,a
		jr	z,break
		dec	e
		dec	e
	}
	dec	d
	dec	d
	dec	d
	{
		ld	a,d
		cp	3
		jr	nc,break

		xor	a
		ld	(ufo_flg),a
		ret
	}
	ld	(ufo_x),de
	ret



;------------------------------------------------
;	UFO~TC
;------------------------------------------------
LaunchUFOMissile:
	ld	a,(enemy_count)
	cp	MAX_ENEMY
	ret	nc

	call	SetUFOMissileData	;~TCf[^쐬

	ld	hl,enemy_count
	inc	(hl)
	ret



;------------------------------------------------
;	UFO\
;------------------------------------------------
DispUFO:
	ld	a,(ufo_flg)
	or	a
	ret	z

	ld	de,(ufo_x)
	ld	hl,Chr_UFO
	jp	PutChr



;------------------------------------------------
;	ˊn{ʓss\
;------------------------------------------------
DispSAMSite:
	ld	de,6*256+DEF_SAM_X+SCREEN_BLANK
	ld	hl,Chr_SAM
	ld	b,11
	call	PutBitmap_OR

	ld	b,6
	ld	d,6			;YW
	ld	ix,CityBuf
	ld	hl,City_coord_data	;XW
	{
		ld	a,(ix+0)
		inc	ix
		ld	e,(hl)
		inc	hl

		add	a,a
		add	a,a
		add	a,a
		add	a,a	;*16

		push	hl
		push	bc

		ld	hl,Chr_CITY
		ld	c,a
		ld	b,0
		add	hl,bc

		ld	b,12
		call	PutBitmap_OR

		pop	bc
		pop	hl
		djnz	continue
	}
	ret



;------------------------------------------------
;	ʉ̐؂芷
;------------------------------------------------
ChangeSe:
	ld	a,(keyf)
	bit	KEY_CLS,a
	ret	z

	ld	a,(sound)
	xor	1
	ld	(sound),a

	ld	b,a
	add	a,a
	add	a,b
	rrca
	rrca
	ld	(_beep+1),a		;00H or 0C0H
	call	Print_SE
	jp	Se2



;------------------------------------------------
;	Xe[^Xʏ
;------------------------------------------------
InitStatus:
	call	Print_VERTICAL
	call	Print_LOGO
	call	Print_HI
	call	Print_SC
	call	Print_LV
	call	Print_BR
	call	Print_SE

	call	DispMissileNum		;ce\
	call	DispScore
	call	DispHiscore
	call	DispLevel
	call	DispEnemyNum		;cG~TC
	ret

	;ce\
DispMissileNum:
	xor	a
	ld	b,33
	ld	hl,ScreenBuf+SCREEN_WIDTH*6+SCREEN_BLANK+101
	{
		ld	(hl),a			;Q[WNA
		inc	hl
		djnz	continue
	}
	ld	a,(my_missile_num)
	or	a
	ret	z
	{
		cp	7
		jr	c,break
		ld	a,7
	}
	ld	de,6*256+101+SCREEN_BLANK
	ld	hl,Icon_MISSILE
	ld	bc,3
	{
		call	PutBitmap		;ACR\
		inc	e
		inc	e
		inc	e
		inc	e
		inc	e

		dec	a
		jr	nz,continue
	}
	ret

	;؂
Print_VERTICAL:
	ld	hl,ScreenBuf+SCREEN_WIDTH+SCREEN_BLANK+WIN_WIDTH
	ld	b,6
	{
		ld	(hl),0ffh
		inc	h
		djnz	continue
	}
	ret

	;^CgS
Print_LOGO:
	ld	de,1*256+98+SCREEN_BLANK
	ld	bc,45
	ld	hl,Font_LOGO
	call	PutBitmap

	inc	d
	ld	hl,Font_LOGO+45
	jp	PutBitmap

	;nCXRA
Print_HI:
	ld	de,3*256+99+SCREEN_BLANK
	ld	bc,13
	ld	hl,Font_HI
	jp	PutBitmap

	;XRA
Print_SC:
	ld	de,4*256+99+SCREEN_BLANK
	ld	bc,13
	ld	hl,Font_SC
	jp	PutBitmap

	;x
Print_LV:
	ld	de,5*256+99+SCREEN_BLANK
	ld	bc,13
	ld	hl,Font_LV
	jp	PutBitmap

	;
Print_BR:
	ld	de,5*256+125+SCREEN_BLANK
	ld	bc,2
	ld	hl,Font_BRACKET
	call	PutBitmap

	ld	e,140+SCREEN_BLANK
	ld	hl,Font_BRACKET+2
	jp	PutBitmap

	;SEACR\
Print_SE:
	ld	a,(sound)
	add	a,a
	add	a,a
	add	a,a			;*8
	ld	e,a
	ld	d,0
	ld	hl,Icon_SE
	add	hl,de

	ld	de,6*256+137+SCREEN_BLANK;41,5
	ld	bc,SE_ICON_SIZE
	jp	PutBitmap



;------------------------------------------------
;	XRA
;------------------------------------------------
InitScore:
	xor	a
	ld	hl,Score	;XRA
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ret


InitHisc:
	xor	a
	ld	hl,Hisc		;nCXRA
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ret



;------------------------------------------------
;	XRAZ
;------------------------------------------------
AddScore:
	{
		ld	hl,city_num		;ss~200
		ld	a,(hl)
		or	a
		jr	z,break

		ld	b,a
		{
			ld	hl,score+1
			ld	a,02h

			add	a,(hl)
			daa
			ld	(hl),a
			dec	hl

			ld	a,0		;XOR AႾ
			adc	a,(hl)
			daa
			ld	(hl),a

			djnz	continue
		}
	}
	{
		ld	hl,my_missile_num	;~TC~50
		ld	a,(hl)
		or	a
		jr	z,break

		ld	b,a
		{
			ld	hl,score+2
			ld	a,50h

			add	a,(hl)
			daa
			ld	(hl),a
			dec	hl

			ld	a,0
			adc	a,(hl)
			daa
			ld	(hl),a
			dec	hl

			ld	a,0
			adc	a,(hl)
			daa
			ld	(hl),a

			djnz	continue
		}
	}
	call	DispScore		;XRA\
	ret



;------------------------------------------------
;	nCXRA̋L^
;------------------------------------------------
CmpHisc:
	ld	hl,Hisc+2
	ld	a,(score+2)
	sub	(hl)
	daa

	dec	hl
	ld	a,(score+1)
	sbc	(hl)
	daa

	dec	hl
	ld	a,(score)
	sbc	(hl)
	daa

	ret	c

	ld	a,(score)
	ld	(Hisc),a
	ld	a,(score+1)
	ld	(Hisc+1),a
	ld	a,(score+2)
	ld	(Hisc+2),a
	ret



;------------------------------------------------
;	XRA\
;------------------------------------------------
DispScore:
	ld	hl,score
	ld	de,4*256+114+SCREEN_BLANK		;114,4
	jp	PutBCD3					;6\



DispHiScore:
	ld	hl,Hisc
	ld	de,3*256+114+SCREEN_BLANK		;114,3
	jp	PutBCD3



DispLevel:
	ld	hl,level
	ld	de,5*256+114+SCREEN_BLANK		;114,5
	jp	PutBCD					;2\



	;cG~TC
DispEnemyNum:
	ld	hl,bcd_enemy_num
	ld	de,5*256+129+SCREEN_BLANK		;129,5
	jp	PutBCD



	;NANWbg@ss
Score_CITY:
	ld	hl,Font_NUM_L
	ld	(_patch_num_font+1),hl

	ld	hl,city_num
	ld	de,2*256+54+SCREEN_BLANK		;54,2
	call	PutBCD

	ld	hl,Font_NUM
	ld	(_patch_num_font+1),hl
	ret


	;NANWbg@~TC
Score_MISSILE:
	ld	hl,Font_NUM_L
	ld	(_patch_num_font+1),hl

	ld	hl,bcd_my_missile_num
	ld	de,3*256+54+SCREEN_BLANK		;54,3
	call	PutBCD

	ld	hl,Font_NUM
	ld	(_patch_num_font+1),hl
	ret



;------------------------------------------------
;	CpXN[
;------------------------------------------------
AddLineScreen:
	ld	hl,LineBuf+SCREEN_WIDTH+SCREEN_BLANK
	ld	de,ScreenBuf+SCREEN_WIDTH+SCREEN_BLANK
	ld	a,6
	{
		push	hl
		push	de
		ld	bc,96			;96dot
		{
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi
			ldi			;32byte
			jp	pe,continue
		}
		pop	de
		pop	hl
		inc	d
		inc	h			;+256

		dec	a
		jr	nz,continue
	}
	ret



;------------------------------------------------
;	XN[\
;------------------------------------------------
DispScreen:
	ld	hl,ScreenBuf+SCREEN_WIDTH+SCREEN_BLANK
	jp	Send_LCDC



;------------------------------------------------
;	ʉ
;------------------------------------------------
Se1:
	push_all
	ld	hl,700		;
	ld	de,4
	call	Beep
	ld	hl,850
	ld	de,4
	call	Beep
	pop_all
	ret

Se2:
	push_all
	ld	hl,480		;
	ld	de,6
	call	Beep
	ld	hl,420
	ld	de,6
	call	Beep
	pop_all
	ret

Se3:
	push_all
	ld	hl,800		;Q[I[o[
	ld	de,20
	call	Beep
	ld	hl,1200
	ld	de,40
	call	Beep
	pop_all
	ret

Se4:
	push_all
	ld	hl,440		;NA
	ld	de,20
	call	Beep
	ld	hl,360
	ld	de,40
	call	Beep
	pop_all
	ret

;------------------------------------------------
;	o[W\
;------------------------------------------------
InfoVer_GAME:
	ld	hl,_g_ver
	ld	de,0			;X=0,Y=0
	ld	b,_g_end-_g_ver
	call	SYS_PUT_STRING
	ret


_g_ver:
	db	'POCKET COMMAND 1.00'
_g_end:



	include	"LIB.ASM"		;Cu
	include "DATA.ASM"		;f[^
	include	"WORK.ASM"		;[NGA



	end
	